{
    'target_defaults': {
        'conditions': [
            ['OS=="mac"', {
                'xcode_settings': {
                    'GCC_PREPROCESSOR_DEFINITIONS': [
                        'TARGET_OS_MAC',
                        'powerc',
                    ],
                    'ARCHS': 'ppc i386',
                },
            }],
        ],
    },
    'targets': [
        {
            'target_name': 'AntaresTest',
            'type': 'executable',
            'sources': [
                'src/TestVideoDriver.cpp',
                'src/TestMain.cpp',
            ],
            'dependencies': [
                'libAntares',
            ],
        },
        {
            'target_name': 'BuildPixTest',
            'type': 'executable',
            'sources': [
                'src/BuildPixMain.cpp',
            ],
            'dependencies': [
                'libAntares',
                '<(DEPTH)/ext/googlemock/googlemock.gyp:gmock_main',
            ],
        },
        {
            'target_name': 'extract-data',
            'type': 'executable',
            'sources': [
                'src/CocoaAdditions.mm',
                'src/ExtractDataMain.cpp',
                'src/FoundationHttpDriver.mm',
            ],
            'dependencies': [
                'libAntaresExtract',
            ],
        },
        {
            'target_name': 'Antares',
            'type': 'executable',
            'mac_bundle': 1,
            'sources': [
                'src/AntaresController.mm',
                'src/AntaresExtractDataController.mm',
                'src/CocoaAdditions.mm',
                'src/CocoaMain.mm',
                'src/CocoaVideoDriver.mm',
                'src/CocoaPrefsDriver.mm',
                'src/FoundationHttpDriver.mm',
                'src/OpenAlSoundDriver.cpp',
            ],
            'dependencies': [
                'libAntares',
                'libAntaresExtract',
            ],
            'xcode_settings': {
                'INFOPLIST_FILE': 'resources/Antares-Info.plist',
            },
            'mac_bundle_resources': [
                'resources/Antares.icns',
                'resources/ExtractData.nib',
                'resources/MainMenu.nib',
            ],
            'link_settings': {
                'libraries': [
                    '$(SDKROOT)/System/Library/Frameworks/AudioToolbox.framework',
                    '$(SDKROOT)/System/Library/Frameworks/Cocoa.framework',
                    '$(SDKROOT)/System/Library/Frameworks/OpenGL.framework',
                    '$(SDKROOT)/System/Library/Frameworks/OpenAL.framework',
                ],
            },
        },
        {
            'target_name': 'libAntares',
            'type': '<(library)',
            'sources': [
                'src/Admiral.cpp',
                'src/AnyCharStringHandling.cpp',
                'src/AresCheat.cpp',
                'src/AresGlobalType.cpp',
                'src/AresMain.cpp',
                'src/Beam.cpp',
                'src/BriefingRenderer.cpp',
                'src/BriefingScreen.cpp',
                'src/BuildPix.cpp',
                'src/Card.cpp',
                'src/CardStack.cpp',
                'src/ColorTable.cpp',
                'src/ColorTranslation.cpp',
                'src/DebriefingScreen.cpp',
                'src/DirectText.cpp',
                'src/EZSprite.cpp',
                'src/Error.cpp',
                'src/Event.cpp',
                'src/FakeDrawing.cpp',
                'src/FakeHandles.cpp',
                'src/FakeMath.cpp',
                'src/Fakes.cpp',
                'src/Geometry.cpp',
                'src/HelpScreen.cpp',
                'src/HttpDriver.cpp',
                'src/ImageDriver.cpp',
                'src/InputSource.cpp',
                'src/Instruments.cpp',
                'src/InterfaceHandling.cpp',
                'src/InterfaceScreen.cpp',
                'src/InterfaceText.cpp',
                'src/KeyMapTranslation.cpp',
                'src/Ledger.cpp',
                'src/LibpngImageDriver.cpp',
                'src/MainScreen.cpp',
                'src/MathSpecial.cpp',
                'src/MessageScreen.cpp',
                'src/Minicomputer.cpp',
                'src/Motion.cpp',
                'src/Music.cpp',
                'src/NateDraw.cpp',
                'src/NatePixTable.cpp',
                'src/NonPlayerShip.cpp',
                'src/OffscreenGWorld.cpp',
                'src/OptionsScreen.cpp',
                'src/Picture.cpp',
                'src/PixMap.cpp',
                'src/PlayAgainScreen.cpp',
                'src/PlayerInterface.cpp',
                'src/PlayerInterfaceDrawing.cpp',
                'src/PlayerShip.cpp',
                'src/Preferences.cpp',
                'src/PrefsDriver.cpp',
                'src/Races.cpp',
                'src/Randomize.cpp',
                'src/ReplayGame.cpp',
                'src/Resource.cpp',
                'src/RetroText.cpp',
                'src/Rotation.cpp',
                'src/ScenarioData.cpp',
                'src/ScenarioMaker.cpp',
                'src/ScreenLabel.cpp',
                'src/SelectLevelScreen.cpp',
                'src/ScrollStars.cpp',
                'src/ScrollTextScreen.cpp',
                'src/SoloGame.cpp',
                'src/SoundDriver.cpp',
                'src/SoundFX.cpp',
                'src/SpaceObjectHandling.cpp',
                'src/SpriteCursor.cpp',
                'src/SpriteHandling.cpp',
                'src/StringHandling.cpp',
                'src/StringList.cpp',
                'src/StringNumerics.cpp',
                'src/Time.cpp',
                'src/Transitions.cpp',
                'src/VideoDriver.cpp',
            ],
            'include_dirs': [
                'include',
                'stubs',
            ],
            'dependencies': [
                '<(DEPTH)/ext/libpng/libpng.gyp:libpng',
                '<(DEPTH)/ext/librgos/librgos.gyp:librgos',
                '<(DEPTH)/ext/libsfz/libsfz.gyp:libsfz',
            ],
            'direct_dependent_settings': {
                'include_dirs': [
                    'include',
                    'stubs',
                ],
            },
            'export_dependent_settings': [
                '<(DEPTH)/ext/libpng/libpng.gyp:libpng',
                '<(DEPTH)/ext/librgos/librgos.gyp:librgos',
                '<(DEPTH)/ext/libsfz/libsfz.gyp:libsfz',
            ],
        },
        {
            'target_name': 'libAntaresExtract',
            'type': '<(library)',
            'sources': [
                'src/DataExtractor.cpp',
            ],
            'dependencies': [
                'libAntares',
                '<(DEPTH)/ext/libpng/libpng.gyp:libpng',
                '<(DEPTH)/ext/rezin/rezin.gyp:librezin',
                '<(DEPTH)/ext/librgos/librgos.gyp:librgos',
                '<(DEPTH)/ext/libsfz/libsfz.gyp:libsfz',
                '<(DEPTH)/ext/libzipxx/libzipxx.gyp:libzipxx',
            ],
            'export_dependent_settings': [
                'libAntares',
                '<(DEPTH)/ext/libpng/libpng.gyp:libpng',
                '<(DEPTH)/ext/rezin/rezin.gyp:librezin',
                '<(DEPTH)/ext/librgos/librgos.gyp:librgos',
                '<(DEPTH)/ext/libsfz/libsfz.gyp:libsfz',
                '<(DEPTH)/ext/libzipxx/libzipxx.gyp:libzipxx',
            ],
            'link_settings': {
                'libraries': [
                    '$(SDKROOT)/System/Library/Frameworks/Cocoa.framework',
                ],
            },
        },
    ],
}
